INCLUDE memory.ld

ENTRY(resetHandler)
PROVIDE(_stack = ORIGIN(ram) + LENGTH(ram));
PROVIDE(__rom_end__ = ORIGIN(rom) + LENGTH(rom));

SECTIONS
{
  .text : {
    LONG(_stack);
    KEEP(*(.core_vectors));
    KEEP(*(.vectors));
    KEEP(*(.init))
    KEEP(*(.fini))
    *(.text*)
    . = ALIGN(4);
    *(.rodata*)
    . = ALIGN(4);
  } >rom

  .preinit_array : {
    PROVIDE_HIDDEN(__preinit_array_start = .);
    KEEP(*(.preinit_array*))
    PROVIDE_HIDDEN(__preinit_array_end = .);
  } >rom
  .init_array : {
    PROVIDE_HIDDEN(__init_array_start = .);
    KEEP(*(SORT(.init_array.*)))
    KEEP(*(.init_array*))
    PROVIDE_HIDDEN(__init_array_end = .);
  } >rom
  .fini_array : {
    PROVIDE_HIDDEN(__fini_array_start = .);
    KEEP(*(.fini_array*))
    KEEP(*(SORT(.fini_array.*)))
    PROVIDE_HIDDEN(__fini_array_end = .);
  } >rom

  .ARM.exidx : {
    __exidx_start = .;
    *(.ARM.exidx*)
    __exidx_end = .;
  } >rom

  . = ALIGN(4);
  __etext = .;

  .data : {
    __data_start__ = .;
    *(.data*)
    . = ALIGN(4);
    __data_end__ = .;
  } >ram AT >rom
  _data_loadaddr = LOADADDR(.data);

  .bss : {
    __bss_start__ = .;
    *(.bss*)
      *(COMMON)
      . = ALIGN(4);
      __bss_end__ = .;
  } >ram

  end = .;
}
